/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2003 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Enemy 饹(ץ쥤䡼Υ饹)Υ饤֥()                */
/*****************************************************************************/

#ifndef _NADAR_SHARE_ENEMY_H_INCLUDED_
#define _NADAR_SHARE_ENEMY_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

typedef struct _Enemy * Enemy; /* Enemy 饹 */

#include "configure.h"

#include "etc.h"
#include "Obj.h"
#include "Path.h"
#include "Map.h"
#include "Tank.h"
#include "Canon.h"
#include "Missile.h"
#include "Explosion.h"

enum {
  ENEMY_TYPE_RANDOM = 0,
  ENEMY_TYPE_NOMOVE, /* ưʤ */
  ENEMY_TYPE_CHASER, /* ɤ */
#if 0
  ENEMY_TYPE_WAITER, /* Ԥ֤ */
#endif
  ENEMY_TYPE_WHIMSY, /* ޤ췿 */
  ENEMY_TYPE_END
};

#define ENEMY_TYPE_START  (ENEMY_TYPE_NOMOVE + 1)
#define ENEMY_TYPE_NUMBER (ENEMY_TYPE_END - ENEMY_TYPE_START)

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

/*===========================================================================*/
/* Ũΰư                                                                  */
/*===========================================================================*/

unsigned long int EnemyAct(Enemy enemy, Map map,
			   ObjList player_list, ObjList enemy_list,
			   ObjList tank_list, ObjList canon_list,
			   ObjList missile_list, ObjList explosion_list,
			   int width, int height, int peeping);
int EnemyInitActions(Enemy enemy);

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Enemy EnemyCreate(char * name, int state, int type);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Enemy EnemyDestroy(Enemy enemy);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_SHARE_ENEMY_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
