/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2003 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Missile 饹(ߥѤΥ饹)Υ饤֥()          */
/*****************************************************************************/

#ifndef _NADAR_SHARE_MISSILE_H_INCLUDED_
#define _NADAR_SHARE_MISSILE_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

typedef struct _Missile * Missile; /* Missile 饹 */

#if 0 /* libm ϻѤʤ */
#include <math.h>
#endif

#include "configure.h"

#include "etc.h"
#include "Obj.h"
#include "Stage.h"
#include "Map.h"
#include "Tank.h"

#define MISSILE_WAIT          0
#define MISSILE_ACTIVE        1
#define MISSILE_EXPLOSION     2
#define MISSILE_DESTROY       3

/*===========================================================================*/
/* ѿμ                                                          */
/*===========================================================================*/

double MissileGetX( Missile missile);
double MissileGetY( Missile missile);
double MissileGetVX(Missile missile);
double MissileGetVY(Missile missile);
int MissileGetState(Missile missile);
int MissileSetState(Missile missile, int s);
Tank MissileGetTank(Missile missile);
Tank MissileSetTank(Missile missile, Tank tank);
Tank MissileGetTarget(Missile missile);
Tank MissileSetTarget(Missile missile, Tank tank);
Tank MissileChangeTank(Missile missile, Tank tank);

/*===========================================================================*/
/* åȤθ                                                          */
/*===========================================================================*/

int MissileSearchTarget(Missile missile, ObjList tank_list);

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Missile MissileCreate(double x, double y, double vx, double vy, Tank tank,
		      int state, Tank target);
Missile MissileCreateFromMissile(Missile old_missile);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Missile MissileDestroy(Missile missile);

/*===========================================================================*/
/* ư                                                                  */
/*===========================================================================*/

int MissileAct(Missile missile, Map map, ObjList tank_list,
	       ObjList explosion_list);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_SHARE_MISSILE_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
