/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2003 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Stage 饹(ơΥ饹)Υ饤֥()                  */
/*****************************************************************************/

#ifndef _NADAR_SHARE_STAGE_H_INCLUDED_
#define _NADAR_SHARE_STAGE_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

typedef struct _Stage * Stage; /* Stage 饹 */

#include "configure.h"

#include "etc.h"
#include "Obj.h"
#include "Map.h"
#include "Player.h"
#include "Enemy.h"
#include "Tank.h"
#include "Canon.h"
#include "Missile.h"
#include "Explosion.h"

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

Map StageGetMap(Stage s);
ObjList StageGetPlayerList(   Stage s);
ObjList StageGetTankList(     Stage s);
ObjList StageGetCanonList(    Stage s);
ObjList StageGetMissileList(  Stage s);
ObjList StageGetExplosionList(Stage s);

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Stage StageCreate(int stage_number, ObjList player_list, ObjList enemy_list,
		  int map_width, int map_height, int width, int height,
		  int peeping, int backward,
		  int interval_time, int timeout_time, int max_players);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Stage StageDestroy(Stage stage);

/*===========================================================================*/
/* ơγ(ФΥᥤ롼)                                      */
/*===========================================================================*/

/* ȯν */
int StageProcExplosion(Map map, ObjList explosion_list);

/* ˤƤν */
int StageProcCanon(Map map, ObjList tank_list, ObjList canon_list,
		   ObjList explosion_list);

/* ߥν */
int StageProcMissile(Map map, ObjList tank_list, ObjList missile_list,
		     ObjList explosion_list);

/* ֤ν */
int StageProcTank(Map map, ObjList tank_list, ObjList canon_list,
		  ObjList missile_list, ObjList explosion_list);

/* ᥤ */
int StageStartAsServer(Stage stage, ObjList player_list, Path request);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_SHARE_STAGE_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
